<?php
// ++=========================================================================++
// || vBadvanced CMPS v2.2.1 - Russian (Repack)
// || © 2003-2007 vBadvanced.com & PlurPlanet, LLC - Все права защищены
// || Русский перевод: Lazek и zCarot.
// ++ ========================================================================++

if ($mod_options['portal_threads_maxthreads'])
{
	if ($mods['modcol'] == 1)
	{
		eval('$home["$mods[modid]"][\'content\'] = "' . fetch_template('adv_portal_latestthreads_head') . '";');

		$mods['colspan'] = 4;

		if ($mod_options['portal_threads_lastpost'])
		{
			$mods['colspan']++;
		}

		if ($mod_options['portal_threads_showforum'])
		{
			$mods['colspan']++;
		}
	}

	$mod_options['portal_threadids'] = unserialize($mod_options['portal_threadids']);

	if (!empty($mod_options['portal_threadids']))
	{
		$mods['threadids'] = 'AND thread.threadid IN(' . implode(',', array_keys($mod_options['portal_threadids'])) . ')';
	}
	else if ($mod_options['portal_threads_forumids'])
	{
		$mods['inforums'] = explode(',', $mod_options['portal_threads_forumids']);

		if ($mod_options['portal_applypermissions'])
		{
			$mods['inforums'] = array_diff($mods['inforums'], $adv_forumperms);
		}
		if (empty($mods['inforums']))
		{
			$mods['nodisplay'] = true;
		}
		else
		{
			$mods['inforums'] = 'AND thread.forumid IN(' . implode(',', $mods['inforums']) . ')';
		}
	}

	if (!$mods['inforums'] AND !empty($adv_forumperms) AND $mod_options['portal_applypermissions'])
	{
		$mods['exforums'] = 'AND thread.forumid NOT IN(' . implode(',', $adv_forumperms) . ')';
	}

	$show['lastpost'] = $mod_options['portal_threads_lastpost'];

	if (!$mods['nodisplay'])
	{
		if ($mod_options['portal_threads_orderby'] == 'dateline')
		{
			$mod_options['portal_threads_orderby'] = 'thread.dateline';
		}

		if (!$mod_options['portal_threads_orderby'])
		{
			$mod_options['portal_threads_orderby'] = 'lastpost';
		}
		if (!$mod_options['portal_threads_direction'])
		{
			$mod_options['portal_threads_direction'] = 'DESC';
		}

		// Table cell classes
		$class_reply = 'alt2';
		$class_view = 'alt1';
		$class_ftitle = 'alt2';

		if ($show['lastpost'])
		{
			$class_reply = 'alt1';
			$class_view = 'alt2';
			$class_ftitle = 'alt1';
		}

		$markinglimit = (TIMENOW - ($vbulletin->options['markinglimit'] * 86400));

		$threads = $db->query_read("
				SELECT
				" . iif($mod_options['portal_threads_showrating'] OR $mod_options['portal_threads_orderby'] == 'voteavg', 'IF(votenum >= ' . $vbulletin->options['showvotes'] . ', votenum, 0) AS numbvote, IF(votenum >= ' . $vbulletin->options['showvotes'] . ' AND votenum != 0, votetotal / votenum, 0) AS voteavg,') . "
				thread.threadid, thread.title, thread.replycount, postusername, postuserid, thread.dateline AS postdateline, IF(views <= thread.replycount, thread.replycount+1, views) AS views, thread.lastposter, thread.lastpost, thread.lastpostid, pollid, thread.forumid
				" . iif($mod_options['portal_threads_showsubscribed'] AND $vbulletin->userinfo['userid'], ', NOT ISNULL(subscribethread.subscribethreadid) AS subscribed') .
				iif($mod_options['portal_threads_showicon'], '
					, thread.iconid AS threadiconid, iconpath AS threadiconpath') .
				iif ($mod_options['portal_threads_showpreview'] AND $vbulletin->options['threadpreview'], '
					, post.pagetext AS preview') .
				iif($vbulletin->options['threadmarking'] AND $vbulletin->userinfo['userid'], '
					, threadread.readtime AS threadread') . "

				FROM " . TABLE_PREFIX . "thread as thread " . 
				iif($mod_options['portal_threads_showicon'], '
					LEFT JOIN ' . TABLE_PREFIX . 'icon AS icon ON (icon.iconid = thread.iconid)') .
				iif($mod_options['portal_threads_showpreview'] AND $vbulletin->options['threadpreview'], '
					LEFT JOIN ' . TABLE_PREFIX . 'post AS post ON (post.postid = thread.firstpostid)') .
				iif ($mod_options['portal_threads_showsubscribed'] AND $vbulletin->userinfo['userid'], '
					LEFT JOIN ' . TABLE_PREFIX . 'subscribethread AS subscribethread ON (subscribethread.threadid = thread.threadid AND subscribethread.userid = ' . $vbulletin->userinfo['userid'] . ')') .
				iif($vbulletin->options['threadmarking'] AND $vbulletin->userinfo['userid'], '
					LEFT JOIN ' . TABLE_PREFIX . 'threadread AS threadread ON (threadread.threadid = thread.threadid AND threadread.userid = ' . $vbulletin->userinfo['userid'] . ')') . "

				WHERE open != 10 AND thread.visible = 1 " .
				iif($mod_options['portal_threads_cutoffdate'], '
					AND thread.lastpost > ' . (TIMENOW - $mod_options['portal_threads_cutoffdate'] * 86400)) .
				iif($ignusers, '
					AND thread.postuserid NOT IN(' . $ignusers . ')') . "
				$mods[threadids]
				$mods[inforums]
				$mods[exforums]
				ORDER BY $mod_options[portal_threads_orderby] $mod_options[portal_threads_direction]
				LIMIT $mod_options[portal_threads_maxthreads]
		");
		$mods['threadcount'] = $db->num_rows($threads);

		while ($thread = $db->fetch_array($threads))
		{
			$bgclass = exec_switch_bg();

			if (!($frmperms["$thread[forumid]"] & $vbulletin->bf_ugp_forumpermissions['canviewthreads']))
			{
				$thread['preview'] = '';
			}

			if (strlen($thread['title']) > $mod_options['portal_threads_maxchars'] AND $mod_options['portal_threads_maxchars'])
			{
				$thread['title'] = fetch_trimmed_title($thread['title'], $mod_options['portal_threads_maxchars']);
			}

			if ($mod_options['portal_threads_maxwordchars'])
			{
				$thread['titlecheck'] = explode(' ', $thread['title']);

				if (!empty($thread['titlecheck']))
				{
					$thread['title'] = '';

					foreach ($thread['titlecheck'] AS $key => $word)
					{
						if (!$thread['titletrimmed'])
						{
							if (strlen($word) > $mod_options['portal_threads_maxwordchars'])
							{
								$word = fetch_trimmed_title($word, $mod_options['portal_threads_maxwordchars']);
								$thread['titletrimmed'] = true;
							}

							if ($thread['title'])
							{
								$thread['title'] .= ' ';
							}

							$thread['title'] .= $word;
						}
					}
				}
			}

			if (!$vbulletin->options['threadmarking'])
			{
				$thread['threadread'] = '-1';
			}
			else if ($thread['lastpost'] < $markinglimit)
			{
				$thread['threadread'] = TIMENOW;
			}

			$thread = process_thread_array($thread, $thread['threadread'], $mod_options['portal_threads_showicon']);

			// Rating
			$thread['votenum'] = $thread['numbvote'];
			if ($mod_options['portal_threads_showrating'])
			{
				$thread['rating'] = intval(round($thread['voteavg']));
			}

			eval('$home["$mods[modid]"][\'content\'] .= "' . fetch_template('adv_portal_latesttopicbits') . '";');
	 	}
	}

	if (!$mods['threadcount'] OR $mods['nodisplay'])
	{
		if ($mods['modcol'] == 1)
		{
			$home["$mods[modid]"]['content'] .= '<tr><td colspan="' . $mods['colspan'] . '" class="' . $bgclass . '">' . construct_phrase($vbphrase['no_x_to_display'], $vbphrase['threads']) . '</td></tr>';
		}
		else
		{
			$show['tablerow'] = true;
			$home["$mods[modid]"]['content'] .= construct_phrase($vbphrase['no_x_to_display'], $vbphrase['threads']);
		}
	}

	$db->free_result($threads);
	unset($thread);
}

?>